#!/usr/bin/env bash
podman build -t jaby_engine .

if [[ -z "${JABY_ENGINE_PATH}" ]]; then
    echo "Setting JABY_ENGINE_PATH to parent folder"

    SCRIPT_DIR="$(cd -- "$(dirname -- "${BASH_SOURCE[0]}")" &> /dev/null && pwd)"
    export JABY_ENGINE_PATH="$(dirname "$SCRIPT_DIR")"
        if cat /etc/passwd | grep $USER | grep bash > /dev/null; then
            # Bash found
            echo "export JABY_ENGINE_PATH="$JABY_ENGINE_PATH"" >> ~/.bashrc 

        else
            # No bash found
            echo "Please add export JABY_ENGINE_PATH="$JABY_ENGINE_PATH" to your shell profile"
        fi
fi