#!/usr/bin/env bash
JABY_ENGINE_DOT_FOLDER="$HOME/.jaby_engine"
JABY_ENGINE_CARGO_FOLDER="$JABY_ENGINE_DOT_FOLDER/cargo/registry"

if [[ -n "${PSX_LICENSE_PATH}" ]]; then
LICENSE_MOUNT="-v ${PSX_LICENSE_PATH}:/psx_license"
else
LICENSE_MOUNT=
fi

PROJECT_PATH_ARR=(${1//:/ })
PROJECT_PATH=${PROJECT_PATH_ARR[0]} 
PROJECT_WORK_DIR=${PROJECT_PATH_ARR[1]} 
shift

if [[ -z "${JABY_ENGINE_NO_DOCKER}" ]]; then
mkdir -p $JABY_ENGINE_CARGO_FOLDER
podman run --rm -it -v $JABY_ENGINE_CARGO_FOLDER:/root/.cargo/registry -v ${JABY_ENGINE_PATH}:/jaby_engine -v ${PROJECT_PATH}:/project $LICENSE_MOUNT -w /project/$PROJECT_WORK_DIR jaby_engine $@
else
echo "WARNING! You are not running in podman"
export JABY_ENGINE_DIR=$JABY_ENGINE_PATH
export PATH="$JABY_ENGINE_PATH/bin:${PATH}"
cd $PROJECT_PATH/$PROJECT_WORK_DIR
$@
fi