use super::create_vram_bg;

use super::MainWindowRef;
use super::{file_tab::FileTab, main_tab::MainTab};

pub struct GUIElements {
    pub file_tab: FileTab,
    pub main_tab: MainTab,
}

impl GUIElements {
    pub fn new(main_window: MainWindowRef) -> Result<GUIElements, slint::PlatformError> {
        main_window.borrow().set_main_tab_vram_bg(GUIElements::create_bg()?);
        Ok(GUIElements{file_tab: FileTab::new(main_window.clone()), main_tab: MainTab::new(main_window.clone())})
    }

    fn create_bg() -> Result<slint::Image, slint::PlatformError> {
        Ok(slint::Image::from_rgba8_premultiplied(create_vram_bg(320, 256).ok_or(slint::PlatformError::Other("Failed creating VRAM background image".to_string()))?))
    }
}